#!/bin/bash
# Java mustang loading script to support KDE settings for Subpixel font rendering
# and Compiz / Beryl compatibility workaround for swing applications
#
# Script made by Trevio (trevi55@gmail.com) <http://3v1n0.tuxfamily.org/blog/>
# Thanks to FindPath function to find the real directory a program resides in.
# Java flags from http://java.sun.com/javase/6/docs/technotes/guides/2d/flags.html
#
# (c) 2006-2007 Trevio, Relased Under FSF GPLv2 Terms.

# Feb. 17, 2000 - Sam Lantinga, Loki Entertainment Software
# Sep, 29, 2006 - Trevio, support for multiple sym-links
FindPath()
{
	fullpath="`echo $1 | grep /`"
	if [ "$fullpath" = "" ]; then
      		oIFS="$IFS"
        	IFS=:
		for path in $PATH
			do if [ -x "$path/$1" ]; then
				if [ "$path" = "" ]; then
					path="."
				fi
			fullpath="$path/$1"
			break
			fi
		done
        IFS="$oIFS"
    	fi
	if [ "$fullpath" = "" ]; then
		fullpath="$1"
	fi
	
	# Is the sed/ls magic portable?
	while [ -L "$fullpath" ]; do
		#fullpath="`ls -l "$fullpath" | awk '{print $11}'`"
		fullpath=`ls -l "$fullpath" |sed -e 's/.* -> //' |sed -e 's/\*//'`
	done
	dirname $fullpath
}

kdeoption()
{
	kreadconfig --group General --key $1
}

# Detecting KDE runinng without gnome-settings-daemon
if ( (kcheckrunning >/dev/null 2>&1) && [ -z $(ps x | grep gnome-settings-daemon | grep -v "grep" ) ] ); then
	if [ "$(kdeoption XftAntialias)" = 'true' ]; then
		case "$(kdeoption XftSubPixel)" in
			none) AAFontType="on";; # could be also "gasp" [better]
			rgb) AAFontType="lcd_hrgb";;
			bgr) AAFontType="lcd_hbgr";;
			vrgb) AAFontType="lcd_vrgb";;
			vbgr) AAFontType="lcd_vbgr";;
		esac
	else
		AAFontType="off"
	fi
	AAfontSettings="-Dawt.useSystemAAFontSettings=$AAFontType"
fi

if [ -n "$(ps x | grep -E "beryl|compiz" | grep -v "grep")" ]; then
	awt_toolkit="MToolkit"
else
	awt_toolkit="$AWT_TOOLKIT"
fi

# Set java style as native GTK+
lookfeel="-Dswing.defaultlaf=com.sun.java.swing.plaf.gtk.GTKLookAndFeel"

# Add here extra options
#export _JAVA_OPTIONS=''

# Running Java with found parameters
AWT_TOOLKIT=$awt_toolkit $(FindPath $0)/java-bin $lookfeel $AAfontSettings $*
